#pragma once

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <dune/common/deprecated.hh>

#include <amdis/AdaptInfo.hpp>
#include <amdis/Environment.hpp>
#include <amdis/Initfile.hpp>
#include <amdis/LinearAlgebra.hpp>
#include <amdis/Output.hpp>
#include <amdis/ProblemStat.hpp>

namespace AMDiS
{
  /// Initialized the Environment for MPI.
  /**
   * NOTE: deprecated
   * Use \ref Environment at the beginning of the main() instead:
   *
   *   int main(int argc, char** argv) {
   *      Environment env(argc, argv);
   *      // do somthing.
   *   }
   *
   **/
  inline void DUNE_DEPRECATED init(int& argc, char**& argv, std::string const& initFileName = "")
  {
    static Environment env(argc, argv, initFileName);
  }

  /// Closes the MPI environment
  /**
   * NOTE: deprecated
   *
   * The \ref Environment is closed automatically on destruction.
   **/
  inline void DUNE_DEPRECATED finalize() { /* no nothing */ }

} // end namespace AMDiS
