#pragma once

#include <type_traits>

#include <amdis/localoperators/FirstOrderTestDivTrialvec.hpp>

namespace AMDiS
{
  /**
   * \addtogroup operators
   * @{
   **/

  namespace tag
  {
    struct divtestvec_trial {};
  }


  /// first-order operator \f$ \langle\nabla\cdot\Psi, c\,\phi\rangle \f$
  template <class LC, class GridFct>
  class GridFunctionOperator<tag::divtestvec_trial, LC, GridFct>
      : public GridFunctionOperatorTransposed<GridFunctionOperator<tag::divtestvec_trial, LC, GridFct>,
                                              GridFunctionOperator<tag::test_divtrialvec, LC, GridFct>>
  {
    using Self = GridFunctionOperator;
    using Transposed = GridFunctionOperator<tag::test_divtrialvec, LC, GridFct>;
    using Super = GridFunctionOperatorTransposed<Self, Transposed>;

  public:
    GridFunctionOperator(tag::divtestvec_trial, GridFct const& expr)
      : Super(tag::test_divtrialvec{}, expr)
    {}
  };

  /** @} **/

} // end namespace AMDiS
