#pragma once

#include <type_traits>

#include <amdis/localoperators/FirstOrderTestvecGradTrial.hpp>

namespace AMDiS
{
  /**
   * \addtogroup operators
   * @{
   **/

  namespace tag
  {
    struct gradtest_trialvec {};
  }


  /// first-order operator \f$ \langle\nabla\psi, c\,\Phi\rangle \f$
  template <class LC, class GridFct>
  class GridFunctionOperator<tag::gradtest_trialvec, LC, GridFct>
      : public GridFunctionOperatorTransposed<GridFunctionOperator<tag::gradtest_trialvec, LC, GridFct>,
                                              GridFunctionOperator<tag::testvec_gradtrial, LC, GridFct>>
  {
    using Self = GridFunctionOperator;
    using Transposed = GridFunctionOperator<tag::testvec_gradtrial, LC, GridFct>;
    using Super = GridFunctionOperatorTransposed<Self, Transposed>;

  public:
    GridFunctionOperator(tag::gradtest_trialvec, GridFct const& expr)
      : Super(tag::testvec_gradtrial{}, expr)
    {}
  };

  /** @} **/

} // end namespace AMDiS
